"use strict";
/// <reference path="./custom.d.ts" />
// tslint:disable
/**
 * IAMU CMS
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * OpenAPI spec version: 0.1
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var url = require("url");
var portableFetch = require("portable-fetch");
var BASE_PATH = "http://http:/api".replace(/\/+$/, "");
/**
 *
 * @export
 */
exports.COLLECTION_FORMATS = {
    csv: ",",
    ssv: " ",
    tsv: "\t",
    pipes: "|",
};
/**
 *
 * @export
 * @class BaseAPI
 */
var BaseAPI = /** @class */ (function () {
    function BaseAPI(configuration, basePath, fetch) {
        if (basePath === void 0) { basePath = BASE_PATH; }
        if (fetch === void 0) { fetch = portableFetch; }
        this.basePath = basePath;
        this.fetch = fetch;
        if (configuration) {
            this.configuration = configuration;
            this.basePath = configuration.basePath || this.basePath;
        }
    }
    return BaseAPI;
}());
exports.BaseAPI = BaseAPI;
;
/**
 *
 * @export
 * @class RequiredError
 * @extends {Error}
 */
var RequiredError = /** @class */ (function (_super) {
    __extends(RequiredError, _super);
    function RequiredError(field, msg) {
        var _this = _super.call(this, msg) || this;
        _this.field = field;
        _this.name = "RequiredError";
        return _this;
    }
    return RequiredError;
}(Error));
exports.RequiredError = RequiredError;
/**
 * @export
 * @namespace Media
 */
var Media;
(function (Media) {
    /**
     * @export
     * @enum {string}
     */
    var TypeEnum;
    (function (TypeEnum) {
        TypeEnum["Text"] = "text";
        TypeEnum["Audio"] = "audio";
        TypeEnum["Image"] = "image";
        TypeEnum["Video"] = "video";
    })(TypeEnum = Media.TypeEnum || (Media.TypeEnum = {}));
})(Media = exports.Media || (exports.Media = {}));
/**
 * CmsApi - fetch parameter creator
 * @export
 */
exports.CmsApiFetchParamCreator = function (configuration) {
    return {
        /**
         *
         * @summary Get the config for a single exhibit
         * @param {string} exhibitId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        exhibitConfigGet: function (exhibitId, options) {
            if (options === void 0) { options = {}; }
            // verify required parameter 'exhibitId' is not null or undefined
            if (exhibitId === null || exhibitId === undefined) {
                throw new RequiredError('exhibitId', 'Required parameter exhibitId was null or undefined when calling exhibitConfigGet.');
            }
            var localVarPath = "/exhibitConfig";
            var localVarUrlObj = url.parse(localVarPath, true);
            var baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            var localVarRequestOptions = Object.assign({ method: 'GET' }, baseOptions, options);
            var localVarHeaderParameter = {};
            var localVarQueryParameter = {};
            if (exhibitId !== undefined) {
                localVarQueryParameter['exhibitId'] = exhibitId;
            }
            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    };
};
/**
 * CmsApi - functional programming interface
 * @export
 */
exports.CmsApiFp = function (configuration) {
    return {
        /**
         *
         * @summary Get the config for a single exhibit
         * @param {string} exhibitId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        exhibitConfigGet: function (exhibitId, options) {
            var localVarFetchArgs = exports.CmsApiFetchParamCreator(configuration).exhibitConfigGet(exhibitId, options);
            return function (fetch, basePath) {
                if (fetch === void 0) { fetch = portableFetch; }
                if (basePath === void 0) { basePath = BASE_PATH; }
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then(function (response) {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    }
                    else {
                        throw response;
                    }
                });
            };
        },
    };
};
/**
 * CmsApi - factory interface
 * @export
 */
exports.CmsApiFactory = function (configuration, fetch, basePath) {
    return {
        /**
         *
         * @summary Get the config for a single exhibit
         * @param {string} exhibitId
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        exhibitConfigGet: function (exhibitId, options) {
            return exports.CmsApiFp(configuration).exhibitConfigGet(exhibitId, options)(fetch, basePath);
        },
    };
};
/**
 * CmsApi - object-oriented interface
 * @export
 * @class CmsApi
 * @extends {BaseAPI}
 */
var CmsApi = /** @class */ (function (_super) {
    __extends(CmsApi, _super);
    function CmsApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     *
     * @summary Get the config for a single exhibit
     * @param {string} exhibitId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CmsApi
     */
    CmsApi.prototype.exhibitConfigGet = function (exhibitId, options) {
        return exports.CmsApiFp(this.configuration).exhibitConfigGet(exhibitId, options)(this.fetch, this.basePath);
    };
    return CmsApi;
}(BaseAPI));
exports.CmsApi = CmsApi;
